/* -------------------------------------------------------------------------------------------------------------------------
* Project           :C-to-FPGA Solution for Acclerating Tomographic Reconstruction
* File Name         :uwer_io.h (from project UW Emission Reconstruction) 
*                    Copyright (c) 2004 University of Washington - Imaging Research Laboratory. All rights reserved.
* Version           :1.0 (V1)
* (V1)Author        :Adam Alessio 
* (V1)Created       :Wed, Jan 14 2004
* References        :
* Description       :Header info for uwer_io.c
*
******This file may not be distributed or modified without this header*****
*-------------------------------------------------------------------------------------------------------------------------*/


#ifndef UWER_IO_H
#define UWER_IO_H
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

//#include <Carbon/Carbon.h>
#include "structs.h"
#include "uwer_ecat_io.h"

void usage_error();
void parse_cmdline_configfile(struct exec_parameters *params,int argc,char **argv);

void prepare_recon_image(struct exec_parameters *params,struct sino_info *sinoInfo,struct recon_image_info *reconImageInfo);
void prepare_forward_projections(struct exec_parameters *params,struct sino_info *sinoInfo,struct recon_image_info *imageInfo);

  
void read_input_sinogram(struct exec_parameters *params,struct sino_info *sinoInfo);
void read_input_avs_sinogram(struct sino_info *sinoInfo,FILE *fp);
void output_recon_image(struct exec_parameters *params,struct recon_image_info *imageInfo);
void read_input_avs_image(struct recon_image_info *imageInfo,struct exec_parameters *params);

void load_system_response_function(struct system_matrix_info *systemInfo,struct exec_parameters *params,struct sino_info *sinoInfo);
#endif
